﻿using System;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using SimpleJSON;

public class Cuffs : MVRScript
{

    #region PluginInfo    
    public string pluginAuthor = "Hazmhox and Frief";
    public string pluginName = "Shackels";
    public string pluginVersion = "1";
    public string pluginDate = "26/05" + "/2022";
    public string pluginDescription = @"Used to open and close the cuffs";
    #endregion

    public GameObject player;
    public GameObject KS_Shed;
  

    protected JSONStorableFloat ScrubA;
    protected JSONStorableFloat ScrubB;
    protected JSONStorableFloat ScrubDistance;


    protected JSONStorableFloat yRotation;
    protected JSONStorableFloat yRotation2;

    private float previousValue1;
    private float previousValue2;


    private float previousZValue;
    private float currentZValue;
    public GameObject ChainEndObject;
    public Transform ObjectRoot;
    public Transform ObjectRoot2;
    public Transform Cuff_R;
    public Transform Cuff_L;
    public Transform Cuff_Open_L;
    public Transform Cuff_Open_R;
    public float distance;
    public float max_distance = 1f;

    private Rigidbody connectedBody = null;


    private bool editorInitialized = false;
    private int initLoops = 0;
    private int SelOption = 0;
    private int maxInitLoops = 100; // 3600 for one minute
    private int i = 0;
    private string atomJSONselectedIndex = null;
    private string atomJSONselectedIndex2 = null;
    protected Atom connectedToAtom = null;

    public float followSpeed = 5f;

    private Vector3 objectRootInitialPosition;
    private Vector3 objectRoot2InitialPosition;

    public override void Init()
    {
        try
        {
            // make atom selector
            atomJSON = new JSONStorableStringChooser("connectedToAtom", SuperController.singleton.GetAtomUIDs(), null, "Connect to Atom", SyncAtom);
            RegisterStringChooser(atomJSON);
            UIDynamicPopup dp = CreateScrollablePopup(atomJSON);
            dp.popupPanelHeight = 1100f;
            // want to always resync the atom choices on opening popup since atoms can be added/removed
            dp.popup.onOpenPopupHandlers += SyncAtomChocies;


            if (containingAtom.type != "CustomUnityAsset")
            {
                SuperController.LogError("Cuffs - Please add this script on a Custom Unity Asset ( script disabled).");
                return;
            }
            //**************  max_distance
            //     ScrubDistance = new JSONStorableFloat("Open/Close Left", 0f, OnSliderChanged1, 0.03f, 180f);
            //   RegisterFloat(ScrubDistance);
            // CreateSlider(ScrubDistance, false);


            //**************  ScrubA
            ScrubA = new JSONStorableFloat("Open/Close Left", 0f, OnSliderChanged1, -180f, 0f);
            RegisterFloat(ScrubA);
            CreateSlider(ScrubA, false);


            //**************  ScrubB
            ScrubB = new JSONStorableFloat("Open/Close Right", 0f, OnSliderChanged2, 0f,180f);
            RegisterFloat(ScrubB);
            CreateSlider(ScrubB, false);

            // A tiny bit of help to give some info to your fellow creator and/or player
            JSONStorableString helpText = new JSONStorableString("About",
                "<color=#000><size=35><b>About</b></size></color>\n\n" +
                "<color=#333>" +
                "Frief CuffDoors Plugin , with help of Hazmhox.\n\n" +
                "The Cuffs can be triggered using Acidbubbles Timeline to open and close.\n\n" +
                "if you have a Cuff open and save the scene the position is also saved.\n\n" +
                "</color>");
            UIDynamic helpTextfield = CreateTextField(helpText, true);
            helpTextfield.height = 1100.0f;

            SyncAtomChocies();
           

        }
        catch (Exception e)
        {
            SuperController.LogError("Exception caught: " + e);
        }
    }

    private void Start()
    {
        objectRootInitialPosition = ObjectRoot.position;
        objectRoot2InitialPosition = ObjectRoot2.position;
    }
    private FreeControllerV3 ChainEnd;
    
    // Update is called once per frame
    void Update()
    {
              
        if (atomJSON.val == null && SelOption == 0)
        {    
            // No option is selected
            SuperController.LogMessage("Please select an Object to connect in the dropdown");
            SelOption = 1;
            
        }
        else
        {
           
            if (connectedBody != null )
            {
                atomJSONselectedIndex = atomJSON.val;

                // I don't know why the fuck this asset does not get the children properly during the loading process, so I'm checking the singleton
                // In reality, that's even cleaner to do it that way
                if (initLoops < maxInitLoops && editorInitialized == false && !SuperController.singleton.isLoading)
                {
                    

                    initLoops++;
                    InitEditor();                

                }

                if (initLoops == maxInitLoops)
                {
                    //SuperController.LogError("Cuff: This CUA could not be initialized properly. Please select a compatible object and reload the script.");
                    initLoops++; // To avoid spamming the log with the error
                }

                if (editorInitialized==true)
                {
                    
                }

                connectTo(ChainEndObject.GetComponent<Rigidbody>());
            }
        }

        /*Vector3 targetPosition = ObjectRoot.position + ObjectRoot.forward * max_distance;
        float distance = Vector3.Distance(ObjectRoot.position, ObjectRoot2.position);

        if (distance > max_distance && ObjectRoot.hasChanged)
        {
            ObjectRoot2.position = Vector3.Lerp(ObjectRoot2.position, targetPosition, followSpeed * Time.deltaTime);
        }
        else if (distance > max_distance && ObjectRoot2.hasChanged)
        {
            ObjectRoot.position = Vector3.Lerp(ObjectRoot.position, ObjectRoot2.position - ObjectRoot.forward * max_distance, followSpeed * Time.deltaTime);
        }*/

    }

    void OnDestroy()
    {
        //Remove all references
        ScrubA = null;
        ScrubB = null;
        Cuff_Open_L = null;
        Cuff_Open_R = null;
        
        // remove all objects that script created
        
        Resources.UnloadUnusedAssets();
    }

    private bool InitEditor()
    { 
        if (i < 2)
        { 
            SuperController.LogMessage("Edtitor initilaised");
            if (connectedBody != null) 
            { 
                ObjectRoot2 = getObjectControlr(connectedBody.transform, "controlr");
            }
            i++;
        }

        if (ObjectRoot == null)
        {
            ObjectRoot = getObjectRoot(containingAtom.reParentObject, "control");
        }else
        {
        }

        if (ObjectRoot != null && ObjectRoot2 != null)
        {

           // max_distance = Vector3.Distance(ObjectRoot.transform.position, ObjectRoot2.transform.position);
           // SuperController.LogMessage("max_distance>> " + max_distance);

            Cuff_Open_L = ObjectRoot.Find("Base/Cuff/Open");
            
            Cuff_Open_R = ObjectRoot2.Find("Base/Cuff/Open");

            if (Cuff_Open_L == null)
            {
                SuperController.LogError("Cuff_Open_L could not be found");
                return false;
            }

            if (Cuff_Open_R == null)
            {
                SuperController.LogError("Cuff_Open_R could not be found");
                return false;
            }

        }

        if (ObjectRoot != null && ObjectRoot2 != null && Cuff_Open_L != null && Cuff_Open_R != null)
        {
            SuperController.LogMessage("We found everthing");
            return true;
            
        }

        return true;
    }

    //just for editing use
   /* void LogObjectHierarchy(Transform obj, int depth)
    {
        // Einrückung für Hierarchie anzeigen
        string indentation = new string('-', depth);

        // Objektnamen ausgeben
        SuperController.LogMessage("LOG " + indentation + obj.name);

        // Rekursiv alle Kinder durchlaufen
        for (int i = 0; i < obj.childCount; i++)
        {
            Transform child = obj.GetChild(i);
            LogObjectHierarchy(child, depth + 1);
        }
    }*/

    // Recursive function searching for a transform containing the string set in objectNameSearchString
    // It is used the first time for the initialization of the script
    // This script NEEDS to use a string "containing" your original because the cloning of the original asset will add "Clone" behind it.
    private Transform getObjectRoot(Transform parent, string rootName)
    {
        
        foreach (Transform child in parent)
        {
            if (child.name.Contains(rootName))
            {
                return child;
            }
            else
            {
                Transform childSearch = getObjectRoot(child, rootName);
                if (childSearch != null) return childSearch;
            }
        }

        return null;
    }

    float GetDistance(Atom atom1, Atom atom2)
    {
        return Vector3.Distance(atom1.transform.position, atom2.transform.position);
    }

    private Transform getChildRoot(Transform parent, string searchName)
    {
        foreach (Transform child in parent)
        {
            
            if (child.name == searchName)
            {

                return child;
            }
            else
            {
                Transform childSearch = getChildRoot(child, searchName);
                if (childSearch != null) return childSearch;
            }
        }

        return null;
    }

    void OnSliderChanged1(float rotation)
    {

        {
            if (Cuff_Open_L == null) return;

            var Slider1 = ScrubA.val;
            var a = -(Slider1 - previousValue1); // Negiere die Drehung
            Cuff_Open_L.localRotation *= Quaternion.Euler(0f, 0f, a);
            previousValue1 = ScrubA.val;
        }

    }

    void OnSliderChanged2(float rotation)
    {
        if (Cuff_Open_R == null) return;

        var Slider2 = ScrubB.val;
        var b = -(Slider2 - previousValue2); // Negiere die Drehung
        Cuff_Open_R.localRotation *= Quaternion.Euler(0f, 0f, b);
        previousValue2 = ScrubB.val;
    }

    protected JSONStorableStringChooser atomJSON;
    protected void SyncAtomChocies()
    {
        List<string> atomChoices = new List<string>();
        atomChoices.Add("None");
        var st = 0f;

        foreach (string atomUID in SuperController.singleton.GetAtomUIDs())
        {
            

            if (findChainEnd(atomUID) !=null)
            {
                Atom atom = GameObject.Find(atomUID).GetComponent<Atom>();
                var containingAtom = findChainEnd(atomUID);
                //SuperController.LogMessage("containingAtom " + containingAtom);

                atomChoices.Add(containingAtom.transform.parent.parent.parent.parent.parent.parent.parent.name);
          
            }
        }
        atomJSON.choices = atomChoices;
    }
   

    
    protected void SyncAtom(string atomUID)
    {

        if (atomUID != null)
        {
            
            connectedToAtom = SuperController.singleton.GetAtomByUid(atomUID);
            atomJSONselectedIndex = atomJSONselectedIndex;
            Rigidbody chainEndRigidbody = ChainEndObject.GetComponent<Rigidbody>();

            if (ChainEndObject!= null && ChainEndObject.GetComponent<Rigidbody>())
            {
                connectTo(ChainEndObject.GetComponent<Rigidbody>());
            }
            else
            {
                SuperController.LogError("ChainEndObject is not an Rigidbody");
            }
        }
        else
        {
            SuperController.LogError("SyncAtom string atomUID = null ");
        }
    }

    Transform getObjectControlr(Transform obj, string targetName)
    {
        Transform parent = obj.parent;
        while (parent != null)
        {
            if (parent.gameObject.name == targetName)
            {
                return parent;
            }
            parent = parent.parent;
        }
        return null;
    }

    private GameObject findChainEnd(string gameObjectName)
    {
        GameObject go = GameObject.Find(gameObjectName);
        if (go == null)
        {
            return null;
        }

        Rigidbody[] rbs = go.GetComponentsInChildren<Rigidbody>();
        foreach (Rigidbody rb in rbs)
        {
            if (rb.name == "ChainEnd")
            {
                ChainEndObject = rb.gameObject;
                return rb.gameObject;
            }
        }
        return null;

    }

    void connectTo(Rigidbody toConnect)
    {
        if (connectedToAtom == null || toConnect == null)
            return;

        foreach (Rigidbody rb in containingAtom.rigidbodies)
        {
          
            if (rb.name == "object")
            {
                ConfigurableJoint fj = rb.gameObject.GetComponent<ConfigurableJoint>();
                if (fj != null)
                {
                    fj.connectedBody = toConnect;
                    connectedBody = toConnect;
                    fj.xMotion = ConfigurableJointMotion.Locked;
                    fj.yMotion = ConfigurableJointMotion.Locked;
                    fj.zMotion = ConfigurableJointMotion.Locked;
                    fj.autoConfigureConnectedAnchor = false;
                    fj.connectedAnchor = new Vector3(0.0f, -0.05f, 0.0f);
                    rb.mass = toConnect.mass;
                }
                else if (fj == null)
                {
                    fj = rb.gameObject.AddComponent<ConfigurableJoint>();
                    fj.connectedBody = toConnect;
                    connectedBody = toConnect;
                    fj.xMotion = ConfigurableJointMotion.Locked;
                    fj.yMotion = ConfigurableJointMotion.Locked;
                    fj.zMotion = ConfigurableJointMotion.Locked;
                    fj.autoConfigureConnectedAnchor = false;
                    fj.connectedAnchor = new Vector3(0.0f, -0.05f, 0.0f);
                    rb.mass = toConnect.mass;
                }
                else
                {
                    SuperController.LogMessage("Hm.. Strange... something happened that can't happen (rb.name != object) connectTo");
                }
            }
        }
    }
    protected UIDynamicSlider BumbnessSlider;
    protected UIDynamicSlider SmoothnessSlider;

    protected void BumbnessCallback(float val)
    {

    }
}
